linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: paulmck@kernel.org
To: linux-kernel@vger.kernel.org, linux-arch@vger.kernel.org,
	mingo@kernel.org
Cc: stern@rowland.harvard.edu, parri.andrea@gmail.com,
	will@kernel.org, peterz@infradead.org, boqun.feng@gmail.com,
	npiggin@gmail.com, dhowells@redhat.com, j.alglave@ucl.ac.uk,
	luc.maranget@inria.fr, akiyks@gmail.com,
	"Paul E. McKenney" <paulmck@linux.ibm.com>
Subject: [PATCH tip/core/rcu 08/32] tools/memory-model: Make judgelitmus.sh detect hard deadlocks
Date: Wed,  2 Oct 2019 17:26:26 -0700	[thread overview]
Message-ID: <20191003002650.11249-8-paulmck@kernel.org> (raw)
In-Reply-To: <20191003001039.GA8027@paulmck-ThinkPad-P72>

From: "Paul E. McKenney" <paulmck@linux.ibm.com>

If a litmus test specifies "Result: Never" and if it contains an
unconditional ("hard") deadlock, then running checklitmus.sh on it will
not flag any errors, despite the fact that there are no executions.
This commit therefore updates judgelitmus.sh to complain about tests
with no executions that are marked, but not as "Result: DEADLOCK".

Signed-off-by: Paul E. McKenney <paulmck@linux.ibm.com>
---
 tools/memory-model/scripts/judgelitmus.sh | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/tools/memory-model/scripts/judgelitmus.sh b/tools/memory-model/scripts/judgelitmus.sh
index d40439c..84c62ee 100755
--- a/tools/memory-model/scripts/judgelitmus.sh
+++ b/tools/memory-model/scripts/judgelitmus.sh
@@ -83,6 +83,14 @@ then
 		fi
 		ret=1
 	fi
+elif grep '^Observation' $LKMM_DESTDIR/$litmus.out | grep -q 'Never 0 0$'
+then
+	echo " !!! Unexpected non-$outcome deadlock" $litmus
+	if ! grep -q '!!!' $LKMM_DESTDIR/$litmus.out
+	then
+		echo " !!! Unexpected non-$outcome deadlock" $litmus >> $LKMM_DESTDIR/$litmus.out 2>&1
+	fi
+	ret=1
 elif grep '^Observation' $LKMM_DESTDIR/$litmus.out | grep -q $outcome || test "$outcome" = Maybe
 then
 	ret=0
-- 
2.9.5


  parent reply	other threads:[~2019-10-03  0:27 UTC|newest]

Thread overview: 33+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-10-03  0:10 [PATCH memory-model 0/32] Memory-model updates Paul E. McKenney
2019-10-03  0:26 ` [PATCH tip/core/rcu 01/32] tools/memory-model: Fix data race detection for unordered store and load paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 02/32] tools/memory-model/Documentation: Fix typos in explanation.txt paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 03/32] tools/memory-model/Documentation: Put redefinition of rcu-fence into explanation.txt paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 04/32] tools/memory-model/Documentation: Add plain accesses and data races to explanation.txt paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 05/32] tools/memory-model: Make judgelitmus.sh note timeouts paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 06/32] tools/memory-model: Make cmplitmushist.sh " paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 07/32] tools/memory-model: Make judgelitmus.sh identify bad macros paulmck
2019-10-03  0:26 ` paulmck [this message]
2019-10-03  0:26 ` [PATCH tip/core/rcu 09/32] tools/memory-model: Fix paulmck email address on pre-existing scripts paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 10/32] tools/memory-model: Update parseargs.sh for hardware verification paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 11/32] tools/memory-model: Make judgelitmus.sh handle hardware verifications paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 12/32] tools/memory-model: Add simpletest.sh to check locking, RCU, and SRCU paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 13/32] tools/memory-model: Fix checkalllitmus.sh comment paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 14/32] tools/memory-model: Hardware checking for check{,all}litmus.sh paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 15/32] tools/memory-model: Make judgelitmus.sh ransack .litmus.out files paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 16/32] tools/memory-model: Split runlitmus.sh out of checklitmus.sh paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 17/32] tools/memory-model: Make runlitmus.sh generate .litmus.out for --hw paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 18/32] tools/memory-model: Move from .AArch64.litmus.out to .litmus.AArch.out paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 19/32] tools/memory-model: Keep assembly-language litmus tests paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 20/32] tools/memory-model: Allow herd to deduce CPU type paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 21/32] tools/memory-model: Make runlitmus.sh check for jingle errors paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 22/32] tools/memory-model: Add -v flag to jingle7 runs paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 23/32] tools/memory-model: Implement --hw support for checkghlitmus.sh paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 24/32] tools/memory-model: Fix scripting --jobs argument paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 25/32] tools/memory-model: Make checkghlitmus.sh use mselect7 paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 26/32] tools/memory-model: Make history-check scripts " paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 27/32] tools/memory-model: Add "--" to parseargs.sh for additional arguments paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 28/32] tools/memory-model: Repair parseargs.sh header comment paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 29/32] tools/memory-model: Add checktheselitmus.sh to run specified litmus tests paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 30/32] tools/memory-model: Add data-race capabilities to judgelitmus.sh paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 31/32] tools/memory-model: Make judgelitmus.sh handle scripted Result: tag paulmck
2019-10-03  0:26 ` [PATCH tip/core/rcu 32/32] tools/memory-model: Use "-unroll 0" to keep --hw runs finite paulmck

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20191003002650.11249-8-paulmck@kernel.org \
    --to=paulmck@kernel.org \
    --cc=akiyks@gmail.com \
    --cc=boqun.feng@gmail.com \
    --cc=dhowells@redhat.com \
    --cc=j.alglave@ucl.ac.uk \
    --cc=linux-arch@vger.kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=luc.maranget@inria.fr \
    --cc=mingo@kernel.org \
    --cc=npiggin@gmail.com \
    --cc=parri.andrea@gmail.com \
    --cc=paulmck@linux.ibm.com \
    --cc=peterz@infradead.org \
    --cc=stern@rowland.harvard.edu \
    --cc=will@kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).